Ant Renamer 2 Help

Ant Renamer 2

Version 2.10 (2008-05-12)

Use the index on the left to naviguate through this help file


What the program does...

This program is designed to rename files. So it will only touch the files' names, it will not modify their contents.

It was made for renaming, but in the Options you can ask it to copy the files instead of renaming them.

It can store a predefined list of actions to reuse them later.

It supports unicode, which means that you can rename files that have characters in Greek, Japanese, Chinese, Arab or any other language. Since most of the programs have problems with such names, it can be useful to be able to rename them to Latin (basic ASCII) characters for example.

... and what it does not

As I said, it won't modify the contents of the files.

It will not either modify files' date & time.

It will not modify the ID3 (tag) contained in MP3s; it only read this info for building a new file name.

It does not read any info from files other than MP3s, and even for MP3s it only reads the v1 of the ID3, not the v2.

It cannot be fully controlled from command line, though it supports some parameters.

Note that the contents of this list is not fixed. Except modifying the contents of the files, all the "does not" things may appear in future versions.

Known bugs and limitations:

  • Unicode is supported only on NT systems (Windows NT4, 2000 and XP).
  • Batch files cannot have unicode characters in their name and path.
  • Ditto for the folder where the program is located, and for the command-line when it is called with parameters.
  • Since version 2.04 the program does not start on some Windows 95 versions, it seems to be caused by a missing Unicode function on these system.
  • In the "Use date & time" action, if you use a long date format (with day or month in letters, like "December" in English), it will fail for days or months that have special characters in their name (like "Décembre" in French). This bug will be corrected soon, but I have to find how to do that.


Main window

The main window of Ant Renamer is divided in three pages:

  • Files: This page contains the list of the files that will be renamed.
  • Actions: This page allows you to select what has to be done to the files.
  • Log: This page contains the list of what has been done (or failed to be done) to the files.

These pages can be accessed through the "Tabs" toolbar which looks like this:
Tabs toolbar

Once you defined the files to rename and how to rename them, click the Go "Go" button. The log indicates you what happened to each file.

The Undo "Undo" button reverts to the old names. It only has one level of undo, so you can only undo the last change that has been made.

The Always on top "Always on top" button, when checked, allows to keep the window always on top of other windows when it is not active.

The Options "Options" button opens the options window.


Files page

This page displays the list of the files that will be renamed.

The toolbar icons used to add and remove files from the list is always displayed, even when the Files page is not active.
Files toolbar

Here are the commands:

  • Add files "Add files" button displays a standard Windows dialog where you can select the files to add, see this page for additional details.
  • Add folders "Add folders" button displays a folder-selection window, that allows to add files and folders as described on this page.
  • Remove selected files "Remove selected files" button removes from the list the files that are selected.
  • Remove all files "Remove all files" button clears the files list.
  • Remove dead files "Remove dead files" button removes from the list the files that do not exist anymore on the disk (missing files). That can happen if, for example, after renaming process you moved some files with Windows Explorer.
  • Refresh preview "Refresh preview" button refreshes the contents of the "Preview" column (and displays it if it is not already visible). This preview is not automatically for performance purposes.

When you click with right mouse button on the headers of the list, a menu appears allowing to select which column has to be displayed or not from the following : Folder, Filename, Full path, Ext. (Extension), Preview, Size, Date created, Date modified.

There are also four buttons allowing to move items within the list, to change the renaming order. You can also drag & drop items within the list to change their order. This order can also be changed by sorting the files by clicking on column headers. To disable this automatic sort, you can click with right mouse button on the headers of the list and select the "Unsorted items" command.

The headers can be resized and moved to change width and order of the columns.

When you click with right mouse button on the list, a menu appears allowing (among other things) to select all items of the list.


Adding files & folders

There are several ways to add files to the list:

  • "Add files" button in main window
  • "Add folders" button in main window
  • Drag & drop files from Windows Explorer

"Add files" button

When you click the Add files "Add files" button a standard Windows file selection appears. This window is controlled by Windows, so it works like in other programs. One thing to know is that the order of the files that will be returned by this window is not especially the order that you see. First, Windows sends the file that is focused (i.e. it has a small dotted border, it is usually the last file that you selected). Then it sends all the files that follow it. When it reaches the end, it jumps to the top to send remaining files.

There may also be some speed problems when trying to add thousands of files. The window may take an eternity to send the filenames to the program. If this is the case, use the "Add folders" function instead.

"Add folders" button

When you click the Add folders "Add folders" button a window appears, allowing you to select one or several folders. This window was not only designed to add folders to the list, but also their contents.

Few options at the bottom of the window allow to specify what should be added to the list:
Options for adding files

The first one specifies if the files contained in selected folder(s) should be added or not. The second one specifies if the selected folder(s) should be added or not. The third one specifies if the sub-folders of selected folder(s) have to be included too (this applies to all sub-levels, not only the first one).

Currently, this window does not display network items or special devices that do not have their own drive letter (network drives that are mapped to a drive letter will be displayed in the list). In the future this may be improved (at least for network items). Until then, a "Network" button allows to choose a folder from a network drive. To add these, the drag & drop may be easier than this window.

Drag & drop files

You can drag & drop files from Windows Explorer (and other program that are compatible with it, like Total Commander or Servant Salamander) directly to the main window of Ant Renamer. This is usually a much easier way to add files than selecting them in the "Add files" window.

By default, when you drop the files a window appears. It allows you to choose how you want to add the files. These options are the same than those available in the "Add folders" window. An option labelled "Do not ask again" allows to keep the select options for future drag & drop, so the window is not displayed again. If you check this option and want to discard it (or change the options), you can do that in the "Files & Folders" page of the Options window. To bring back this window one time without changing its default behaviour, you can hold down the Ctrl or Shift key while dropping the files. This allows, for example, to add a folder to the list when the default behaviour that you select is to only add files.

The same limitations than for the "Add files" window apply (files order and speed problems with lots of files).


Actions page

This page displays the actions that can be applied to the files.

  • Change extension
  • String replacement
  • Multiple string remplacement
  • String insertion
  • Move string
  • Characters deletion
  • Enumeration
  • Use mp3 tag info
  • Use date & time
  • Random names
  • Change case
  • Take names from list
  • Regular expression
  • Use EXIF info

This page has also commands to manage batch files. In addition to the Files toolbar which is always visible, a toolbar to manage these batch files is displayed. For more information about bathes, see this page.

At the bottom of the window, there are two panels:

  • Preview of selected file, which displays the current and future name of the selected file of the Files list (or first file if none is selected). This preview is refreshed at each change in actions paramters, allowing you to directly see the results of what you change in these parameters.
  • Batch contents (hidden by default), which displays the planned actions. It is described on the "Batch" page.

You can hide/show these panels using the checkbox at the left of their title.

Change extension

You can override the extension by a new one, or append the new one after existing one if you check the option for that.

The dot will be added in front of your extension. To remove current extension, simply leave the field empty.

String replacement

You can replace a text by another in the filenames. If the "Replace all occurences" option is not checked, only the first occurence of the text in each filename will be replaced.

This action can be also used for inserting a string before or after an existing one (if you do not know the position where the new string has to be placed). For example, if you want to insert "2" after all the "test" contained in names, replace "test" by "test2".

It can also be used for deleting a specified string: simply leave the second field empty for that.

Multiple string replacement

You can enter here multiple strings to replace. The left column contain the strings to search in names, the right column contains the text to put instead (which can be an empty string).

At first it was added for multiple character replacement, like replacing all accentuated characters by their latin equivalent. But I added support for strings instead of characters for some languages where one character may have to be translated to several latin characters, or vice versa.

You can save the grid contents to retreive it later from the drop-down list. Type a name in this field and click "Save".

To add a line in the grid, press "Ctrl" and "Plus" (+) keys. The new line will be added before the selected cell.

In the same way, pressing "Ctrl" and "Minus" (-) keys will remove current line.

String insertion

You can insert a string at any position, counting from begin or end of the name. Zero means that the string will be inserted before the first existing character or after the last one.

The extension is not included when counting characters, so an option to apply this to extension instead of name is provided.

This action supports the following tags :

  • %name% : Put the original name of the file, without extension
  • %ext% : Put the original extension of the file, including the dot
  • %folderN% : Put the N-th parent folder

    • See the chapter consacred to folder tag on the "Formatting" page for more information.

    Move string

    You can move a predefined number of characters from a place to another of the name. Like for string insertion, the "From" and "To" position start at 0 (where 0 = before first character or after last one).

    The "To" position counts the characters in the remaining ones. It means that first the specified number of characters are deleted, then the program will try to insert them again.

    For example, in "abcdef" string, if you move 1 character from position 2 (the "c") to position 4, it will not appear after the "d" but after the "e": since the "c" has been removed, the "d" becomes the third character and the "e" the fourth.

    Characters deletion

    You can specify here a number of characters to cut, from a position (like for string insertion) or after a string.

    Enumeration

    For this action, you have to specify a mask. This mask has to contain at least the %num% tag, to indicate to the program where to put the number that it will generate.

    • %name% : Put the original name of the file, without extension
    • %ext% : Put the original extension of the file, including the dot
    • %num% : Put the current number

    For example, if you want to call your images "File 0001.jpg", "File 0002.jpg", etc. you can enter File %num%%ext%. You can put ".jpg" instead of "%ext%" if you do not want to keep original extension (or if all are the files are JPEG).

    See the "Formatting" page for more information about masks and tags.

    "Start at" is the number to give to the first file. "Number of digits" represent the minimum number of digits to write (if the current number as less digits, zeroes will be added in front of it; put this field at 1 if you do not want to insert zeroes in front of numbers). "Increment" is the amount added for each file.

    If the files are grouped by folders (i.e. the primary sort is the folder name, so the folders' contents are not mixed in the list) you can use the option "Go back to start value...". It will restart at the "Start at" value when the current file is in another folder than the previous one. This allows to make same kind of enumeration in lots of folders without having to do the operation for each folder separately.

    Use mp3 tag info

    Here again you have to enter a mask. There are few special tags recognized. See the "Formatting" page for more information.

    • %author% : Author/Artist
    • %title% : Title of the song
    • %album% : Album name
    • %year% : Year
    • %genre% : Genre/Category
    • %comm% : Comment
    • %track% : Track number, which is only present since ID3v1.1 and which is stored instead of the last byte of Comment field.

    %name% and %ext% tags are also available.

    Since a mp3 tag can contain any character, an option allows to remplace forbidden characters. Quotation marks "..." will be replaced by double apostrophes ''...'' (two ' together). Question mark will be replaced by a point (dot). Other characters will be replaced by a dash.

    Use date & time

    This action uses a different mask system. The tags are simple letters:

    • f : Original filename (without extension)
    • e : Original extension (including dot)
    • c : Date and time using the standard format in Windows
    • d : Day without a leading zero (1-31)
    • dd : Day with a leading zero (01-31)
    • ddd : Day, short name (Sun-Sat)
    • dddd : Day, full name (Sunday-Saturday)
    • ddddd : Date using Windows' short date format
    • dddddd : Date using Windows' long date format
    • m : Month without a leading zero (1-12)
    • mm : Month with a leading zero (01-12)
    • mmm : Month, short name (Jan-Dec)
    • mmmm : Month, full name (January-December)
    • yy : Year, 2-digit number (00-99)
    • yyyy : Year, 4-digit number (0000-9999)
    • h : Hour without a leading zero (0-23)
    • hh : Hour with a leading zero (00-23)
    • n : Minute without a leading zero (0-59)
    • nn : Minute with a leading zero (00-59)
    • s : Second without a leading zero (0-59)
    • ss : Second with a leading zero (00-59)
    • am/pm : Uses the 12-hour clock for the preceding h or hh (can be in uppercase)
    • a/p : Uses the 12-hour clock for the preceding h or hh (can be in uppercase)

    If m or mm immediately follows h or hh, minute rather than month is used

    Be careful with date and time formats, especially when using Windows' format. The "/" and ":" are often used as delimiters, but they cannot be used in a filename. So if you use these as default delimiter, you have to insert manually other delimiter between quotes, as explained in next paragraphs.

    Here all the character that are not part of the mask have to be put inside quotes (single or double). I recommend to use double quotes (quotation marks "...") instead of single (apostrophes '...') so you can put apostrophes inside the quotes.

    Here are few valid examples:

    • yyyy'-'mm'-'dde : Uses yyyy-mm-dd date format, foces separator to be "-", and keeps original extension.
    • "a'b" yyyymmdd".txt" : Here is an example of including an apostrophe inside a quote. A ".txt" extension is forced.
    • yy'-'mm'-'dd hh'-'nn'-'sse : Also includes the time in the name, in 24-hour format.
    • yy'-'mm'-'dd hh'-'nn'-'ss am/pme : Same, but using 12-hour format (with am/pm) instead of 24-hour. The am/pm is displayed after the whole time.

    Since multiple files can have the same date (or time), an option can be checked to add a suffix after the duplicate files. This suffix is a long number. In a future version it will be possible to control this better.

    You can choice to use either creation date/time or last modification date/time. The first one is the date when the file was put on the disk, the second one is the date when the file was modified. If you recently put an old file on a new disk, the creation date may be more recent than the modification date. Most of the time it is the modification date that is used.

    Random names

    Using the same mask system than Enumeration and Use mp3, you can generate here new names that will contain a random part. Like in these two actions, %name% and %ext% tags are also available.

    The %random% tag will put a random number, generated according to one of these options:

    • Random number : Generates 8 digits randomly.
    • Windows tick count : This is not really a random number, it is Windows' tick count. It is the number of milliseconds since Windows started (and returns to zero after about 49.7 days), so these numbers are sequencial.
    • GUID : These special strings are very long identifiers, designed to be unique (generated using network address, date, time and other similar data). You can be sure that you will never get two identical GUID. The only downside is that they do not look very good, e.g. "{FC7F6B42-A25A-47B1-96A7-52A12BC36A02}".

    Change case

    With this action it's only the case (uppercase/lowercase) of the letters that will change, so the name will not really change since names are case-insensitive on Windows systems.

    You can make different kinds of changes. The first one, "Upper first letter following...", is usually used to make mixed-case names (i.e. you have to put in the field characters like space, dash, dot, etc.)

    Usually it is better to keep the option "Use Windows' locale..." checked. This will ask to Windows to change the case, so depending of the current language settings the accentuated characters will be properly modified. If this option is not checked, only standard latin letters (a..z) are modified.

    Take names from list

    For this action, you simply have to give a list of the new name. Ant Renamer will rename the files to these names.

    By default it takes each line as a full name, but if you do not want to override extensions (i.e. take the name without extension from the list and then append original extension) you can check the option "Append original extension..."

    You can also simply give a list of extensions, and check the "Use items as extensions..." option. Then the names will not be modified.

    If the list is too short, the files that do not have a matching line from the list will not be renamed. Same when an empty line is found in the file.

    Regular expression

    If you are familiar with the syntax of these expressions, you will be able to quickly extract part of the file names to generate a new name in one step rathing than having to combine several actions. You can even achieve some changes that could not be done with the classic move/insert/delete actions.

    You need to provide to the program a regular expression and a "new name" string that contains $nn tags (where nn is a number) indicating where to place the characters found in the original file name.

    For more information about the syntax of the regular expression, see the page dedicated to this.

    Use EXIF info

    Using the same mask system than several actions described above, you can generate with this action a new file name based on EXIF data contained in JPEG pictures. This can be, for example, very useful as replacement of the Use date & time action if the dates of your photos are not kept when you transfer them from your digital camera.

    See "Formatting" page for more information. Due to the very long list of existing EXIF tags, they are listed on a separate page rather than being included here.


Predefined list (batch)

Ant Renamer can store and retrieve predefined lists of actions, called here "batches". They can be manager from the Actions page.

In addition to the Files toolbar which is always visible, a toolbar to manage these batch files is displayed:
Batch toolbar

Here are the commands:

  • Add to batch "Add action to batch" button will add currently selected action and its parameters to the list.
  • Remove from batch "Remove selected actions" button will remove from the list the items that are selected.
  • Clear "Clear batch" button will remove from the list all the predefined actions.
  • Open "Open" button will display a standard file selection window, so you can select a batch file to load in the list.
  • Save "Save" button will display a standard file selection window, so you can select where to save the contents of the list for a future use.

These batch files can be used for combining multiple actions in one renaming process. They can be saved for a future use, or to use them from command-line.

They are stored as XML files, but they have a ".arb" extension (meaning "Ant Renamer Batch").

The list of current planned actions is displayed in the bottom panel, called "Batch contents". If it is not visible, you can show it by clicking on the checkbox at the left of its title.

You can move the items up and down in the list by drag & drop or using the four additionnal icons that appear in the toolbar when the batch panel is visible.

After having been added, an item cannot be modified. You have to remove it, redefine the parameters and add it again for that.


Formatting strings

In some actions, you can use special tags that are delimited by "%" characters.

Since the "%" is then used as a special character, so have a simple "%" in the file name you have to enter "%%".

In each action that support special tags, the available tags are listed in the "Notes" text under the parameters of this action.

For example, the Use mp3 action supports ID3-related tags, like %author% and %title% in addition of %name% and %ext%. So a typical mask for mp3 files would be something like %author% - %title%%ext% (%ext% includes the dot, so we do not need to put the dot in the mask used here).

A %folderN% tag is usually available. This tag allows you to use the name of the parent folders in the filename itself. This is a little difficult to explain, so I'll give you some examples.

If you have a file in "c:\data\images\movies\poster.jpg" and that you use the String insertion action:

  • With mask = %folder1% -  the file will be renamed to "movies - poster.jpg"
  • With mask = %folder2% -  the file will be renamed to "images - poster.jpg"
  • etc.

You can also use a relative path, e.g. if you have several folders, each one having lots of files in it, and all of these files are not especially unique between two different folders. You may want to insert folder name and then move all the files to the common parent folder. Here is an example; you have the following files:

  • c:\data\images\movies\poster1.jpg
  • c:\data\images\games\poster1.jpg
  • c:\data\images\games\poster2.jpg

If you rename them will String insertion action and a string like ../%folder1%  inserted at position 0 from beginning, you will get the following in the "images" folder:

  • movies poster1.jpg
  • games poster1.jpg
  • games poster2.jpg

Now you can delete the empty "movies" & "games" folders.

If you enter a negative number instead, the count will be done from the root rather than from the current folder. So still using "c:\data\images\movies\" as folder:

  • %folder-1% = "c"
  • %folder-2% = "data"
  • %folder-3% = "images"
  • etc.

Using the %name% tag, you can also want to have the files placed in a folder that takes the file's name. For that, the "Force directories" option has to be enabled. If you have the following files:

  • cars.doc
  • cars.xls
  • cars.jpg
  • houses.doc
  • houses.xls
  • houses.jpg

Still with the String insertion action, using a string like %name%\ inserted at position 0 from beginning, you will get the three "cars" files in a "cars" folder, and the three "houses" files in a "houses" folder.

When renaming folders, %count% and few derivated tags are available:

  • %count% = number of files and subfolders contained in renamed folder
  • %countr% = same but also counts what is in subfolders (recursive)
  • %countfiles% = counts only files
  • %countfilesr% = same but includes files of subfolders (recursive)
  • %countfolders% = counts only sub-folders
  • %countfoldersr% = same but includes subfolders of subfolders (recursive)

For the Use mp3 tags and Use EXIF info actions, there is also a special tag: $if. It allows you to make conditional formatting. For example, when a field is empty you may want to not display the " - " that follows it. Or to put a special value.

The syntax is the following: $if(condition,value-if-true,value-if-false). If "condition" is not an empty string, value-if-true will be used. In the other case, value-if-false will be used. Since you may need to use commas and parenthesis inside the $if function, you can put the values inside quotation marks ("...") to prevent them from being analyzed. But be careful with them: they also prevent the %tag% from being analyzed.

Here are some examples that will explain that better. In the files list there are two mp3 files that has a bad name (1.mp3 and 2.mp3) but that has the following valid ID3 information:

  • 1.mp3: Author = Blur, Title = Song 2, Album is emty, Track is empty
  • 2.mp3: Author = Vivaldi, Title is empty, Album = Le Quattro Stagioni, Track = 1

Here is the result using various masks:

%author% - %title%%ext%
Simply take the author and title, separated by a dash. Here we are not using the if function, and the result is not really nice when there are empty fields.

  • Blur - Song 2.mp3
  • Vivaldi - .mp3

%author%$if(%title%, - %title%,)%ext%
Take the author and, if the title is not empty, add a dash and the title.

  • Blur - Song 2.mp3
  • Vivaldi.mp3

%author%$if(%album%," ("%album%")",)$if(%title%,", "%title%,)%ext%
Take the author, if it exists add the album name between parenthesis, then if it exists add the title separated by a comma. Here you see that parenthesis and comma have to be put between quotes to not be taken as "end of if" or value separator.

  • Blur, Song2.mp3
  • Vivaldi (Le Quattro Stagioni)

%author%$if(%album%," ("%album%")",)$if(%title%,", "%title%,$if(%track%, - %track%,))%ext%
Same as previous one, but inside the title's if we add another if to add the track number only in the case that the title is empty.

  • Blur, Song2.mp3
  • Vivaldi (Le Quattro Stagioni) - 1


Regular expressions

Ant Renamer uses the TRegExpr library. You can find a syntax reference on the site dedicated to this library. These expressions are quite complex but also quite "standard", so I won't make here a detailed guide explaining how they work.

For the "Regular expression" action, you have to provide two values:

  • Expression, containing a valid regular expression;
  • New name, containing the new name of the file, with $nn backreferences (nn being a number) to indicate where found strings have to be inserted. Note: these backreferences are presented with "\" instead of "$" on the syntax page mentionned above.

Lots of non-alphanumeric characters have a special meaning in regular expressions. To use them, the escape character is the backslash ("\"). This also applies to the "$" sign that has a special meaning in the "new name" field. If you need to use the backslash as a character (e.g. as path delimiter in the new name) you have to double it ("\\").

Examples

Swapping artist and title from mp3 file names:

  • Expression = (.*) - (.*)\.mp3
  • New name = $2 - $1.mp3

Extract episode number and title from series video files with episode number as SnnEmm followed by title:

  • Expression = Code\.Quantum\.S([0-9]{2})E([0-9]{2})\.(.*)\.FRENCH.XViD\.avi
  • New name = Code Quantum - $1$2 - $3.avi


Log page

This page is filled with the results of the renaming process.

In addition to the Files toolbar which is always visible, a toolbar for the log is displayed:
Log toolbar

Here are the commands:

  • Filter "Filter" button will show a menu, which allows you to specify which kind of items you want to see in the log (depending of their status; see next paragraph).
  • Clear "Clear" button will empty the log.
  • Save "Save" button will open a standard file selection window, allowing you to choose where to save the log contents.
  • copy "Copy" button will copy the log contents to Windows' clipboard.

When the renaming was fine, a line in the log is added specifying the old and new name of the file. It is written in green.

In the case the file was not renamed, either an simple message (in blue) or an error (in red) is displayed.

The first case is caused by identical destination name (no need to rename the file) or if the file does not contain ID3 info (for mp3 renaming). It can also happen when the source file does not exist anymore (e.g. you moved it manually).

The errors can be caused by lots of things. For example, if the new target name is already used by another file, if the name contains invalid characters or if the file is locked by a program. Usually the message written is the one that Windows returns.

If you get a message "The operation completed successfuly" listed as an error, it means that the real error message has been lost or that the error was not properly detected. Please contact me if you can reproduce the problem.

Automatically save log to file

This can be done with the "Save log to file" option from the Options window.

If the option is enabled, after the renaming operation the contents of the log will be stored in a text file (encoded in UTF-8).

This file has two columns (delimited by a tab character). The first one contains a "v" for successful operations and a "x" for errors. The second one contains the message.

If the "Append" option is also enable, the file will not be overwritten: new log entries will be added at the end.


Options window

This window is accessible through the Options "Options" icon of the main window. It is divided in four pages:

Display

  • Real-time update when renaming files : The lists contents are updated each time a file is renamed. It is quite slower if you rename thousands of files or on a slow machine.
  • Auto-resize columns of Files list : When enabled, the program will always try to fit the columns of Files list (main window) in the width of the window.
  • Show icons in files list, based on file extension : Displays icons on the left of the items of the Files list. It may slow down a little the scrolling of the list, and since each ".exe" file has its own icon it may be quite slow for files coming from a network drive for example.
  • Force the following font for controls that have to display special characters : Allows to specify the font to use for the fields that may contain unicode characters, including Files and Log lists. If available, the fond "Arial Unicode MS" is used by default. Click here for more information.
  • Number of values to keep in history : The drop-down lists remember the last text strings that you used. You can specify here how much strings have to be kept (0 = none).
  • Autocomplete with history values when typing : When you type the text, if it has the same beginning than an existing item of the history this item will be copied in the field (the part you did not type is selected, so you can continue to type to overwrite it).
  • Icon set : Icon set to use for toolbars. The program includes a set called "Scrows". Additional files can be put in the "Toolbars" folder. Default installation includes two additional sets: "Windows XP" and "Windows XP Large" (the second one is the same but it has larger icons).
  • Color type : How the icons should be painted when the mouse is not over them. "Automatic" takes one of the value depending of the current Windows theme (classic or themed XP) and the "Office XP style" option. "Always colored" keep the icons always with their original colors even when the mouse it not over them.
  • Office XP style : Makes toolbars and menus look like those of Microsoft Office XP.

Files & Folders

  • Do not ask what to do, always use the following options : Prevents from displaying a window each time you drag & drop files to Ant Renamer window. You can specify here the options instead of having to select them each time. These options are detailed in the chapter "Adding files & folders".
  • Launch file on double click : If this option is enabled, when you double-click on a file from the Files list it will be opened like if you double-clicked it in Windows Explorer.

Processing

  • Force directories : A "\" character is not valid in a file name since it is used as path delimited (e.g. c:\Program Files\Ant Renamer\Renamer.exe). So when a "\" is found in a file name the part before the "\" is considered as a folder. To be able to move the file to this folder, it must exist. If this option is checked, before renaming/moving each file the program will check that the folder exists, and will create it if it is not found.
  • Detect a ":\" or "\\" as an absolute path : When this option is enabled, if the new file name begins by "x:\" (x = any letter) or by "\\", then the old path will not be added in front on it. This allows to move the files anywhere by giving the full path as new file name.
  • Copy instead of Rename : Though the program is designed for renaming file, it can sometimes be useful to copy the files to a new name instead of rename them.
  • Generate log : If this is disabled, the Log page of the main window will not be filled with all the files processed.
  • When started : Allows to define what to do before starting to rename files, when you click the "Go" button.
  • When finished : Allows to define what to do when renaming process is complete. The "Save log to file" option allows to store the log contents to a file. See "Log page" for more information.

Language

  • In this page you can select the language to use in the user interface.
  • Except for English, the langages can only be displayed correctly if your PC is configured to use the same character set than the langage uses. This depends of the settings defined in the "Regional and language options" of Windows' Control Panel.


Font used for special characters

In the options window you can select which font has to be used in fields that have to display special characters. This option is only available under NT systems (NT4, 2000, XP) since Unicode is not supported on Windows 9x.

If you only use basic latin characters, you can select any font (e.g. "MS Sans Serif" which is the default for American & West-European systems). But if special or foreign character are not displayed correctly (e.g. you see squares instead of the characters), you may need to select a different font.

By default, the program tries to use "Arial Unicode MS". This font comes with Microsoft Office but is not included in default install.

Unfortunately I cannot distribute this font. It is the most complete font that I've seen, so if you have Microsoft Office I recommend to install this font (it is called "Universal font" in the installation options).

There was also a font called "Bitstream Cyberbit" that had lots of characters, but it is not available anymore from Bitstream's site.

If you do not have one of these two fonts, you can try to use Arial, Verdana or Tahoma that are included with Windows. But they do not include lots of characters.

If you have more information about a freeware font that has more unicode characters than Arial, please contact me so I can include these information here.

The "Arial" font included in Windows 2000/XP should work for all European (West & Central) languages, Cyrillic, Greek, Hebrew and Arabic.

Here is a list of the font that can be used for some Asiatic langages, if they are installed on your system (those are used by Internet Explorer and Mozilla for displaying web pages that are written in these langages).

Japanese: | MS PGothic, MS PMincho, MS Gothic, MS Mincho
Traditional Chinese: | MingLiU
Simplified Chinese: | SimSun, NSimSun
Korean: | GulimChe
Thai: | Tahoma


Command-line parameters

The program does not (yet) support lots of parameters. It is not really possible to rename files by specifying all the rename parameters from the command line, but they can be given through a saved batch file.

Here is the list of supported parameters:

  • -b FileName.arb : Loads the batch file called FileName.arb
  • -g : Launches the renaming process after files have been added and batch file loaded
  • -x : Quits the program after the renaming process
  • -a : Change the file add mode, based on the letters following the "-a" parameter:
    • f : Add files from filenames/paths that follow
    • F : Add folders that follow, or contained in folders, see examples
    • r : Recursive addition of folders' contents

The filenames and paths can be relative or absolute, and they can contain wildcards (* and ?).

Here are some examples:

  • Renamer.exe -b d:\test.arb -af c:\data\*.* -g -x
    This will load the batch file specified, add all files contained in c:\data folder, start renaming and then exit
  • Renamer.exe -af c:\data
    This will add the file called c:\data
  • Renamer.exe -afr c:\data
    This will add the file called c:\data. If it is a folder, it will add the files that it contains (recursive search)
  • Renamer.exe -aF c:\data
    This will add the "data" folder
  • Renamer.exe -aF c:\data\*.*
    This will add the folders containted in the "data" folder, but not the files
  • Renamer.exe -af c:\data\*.* c:\images\*.jpg c:\test.txt -afr c:\mp3\*.*
    You can combine several paths/filenames, use masks, and use different "-a" parameters in one command line

If a name is given without any "-a" parameter, it will be analyzed like in Ant Renamer 2.07 (and older) : if a filename ending by ".arb" is given, it is loaded as batch file; if a folder is given, its contents is added recursively (files only, does not support wildcards, requires a full folder name).

It is possible to add Ant Renamer in the "Send to" list (in the menu that appears when you click with right mouse button on a folder in Windows Explorer). So this adds the possibility to send a folder to Ant Renamer from its contextual menu, to load its content in the files list. To do that, go to "Start" -> "Run" and type sendto. A folder window should open; place there a shortcut to Ant Renamer.


Ant Renamer Help

Version history

2.x versions:

  • 2.10 (12/05/2008)
    • Replaced component used for number fields.
    • Added %count% tag, and improved the %folder% tag.
  • 2.09 (09/09/2006)
    • Characters deletion: option to also delete characters before a specified string.
    • Added a new action for using data contained in JPEG EXIF tags.
    • Added a new action for generating new names using a regular expression.
    • When the "Shift" or "Ctrl" key is pressed when adding files/folders by drag & drop, the files/folders/subfolders addition options window is always displayed.
    • Few bugs corrected
  • 2.08 (15/10/2004)
    • Help file
    • Added support for some command-line parameters, see help file.
    • More advanced formatting system for some actions, especially for mp3.
    • Option for using Creation date instead of Modification date, in Date & time action.
    • Option for reverting to start value when changing folder, in Enumeration action.
    • Option for storing log to a file, with or without append.
    • Possibility to filter log entries (successes, errors, not renamed files).
    • Few bugs corrected
  • 2.07 (06/02/2004)
    • "Move string" action.
    • Few bugs corrected, few options added in actions.
  • 2.06 (23/09/2003)
    • Modified toolbar system, and switched from TBSkin to TBX (dropped "Windows XP" theme on non-XP systems).
    • "Multiple string remplacement" allowing to replace a set of characters by another set, e.g. remove accents on letters.
    • Faster log (it was really slow when renaming hundreds of files).
    • Corrected "preview" bug when using planned actions list.
  • 2.05 (18/05/2003)
    • Optional columns in file list : size, date created, date modified, full path, extension.
    • Items in Files and Batch list can now be moved by drag & drop.
  • 2.04 (04/05/2003)
    • Can rename folders in addition of files. This required few changes in the "Add folder contents" and Drag & Drop operations.
    • Option to move files to another path if their new name starts with "x:\" (where x is any letter) or "\\".
    • Option to specify the maximum number of items to keep in drop-down lists.
    • Few other small changes, and corrected a bug with the drag & drop of long file names under NT/2000/XP.
  • 2.03 (13/04/2003)
    • Unicode support under Windows NT4, 2000 and XP.
    • Batches can be saved and loaded.
  • 2.02 (06/04/2003)
    • Option (enabled by default) to display icons in the file list (based on the extensions of the files).
    • Toolbars positions and list columns settings are now saved.
  • 2.01 (25/03/2003)
    • Added a French translation and a sample English translation file, to allow any translation to be made.
    • Corrected a bug that sometimes stopped the renaming process before the end.
  • 2.00 (16/03/2003)
    • Option to copy files to new name instead of rename them.
    • Added few missing things. Now all what was in version 1.4 should be there (except translation system).
  • 2.00 'Preview 1' (08/03/2003)
    • Very long time since last update, because this version is a complete rewrite of the program with Borland Delphi 7 (instead of C++Builder 5).
    • Possibility to make a list of actions to apply.
    • Corrected lots of bugs (but probably added new ones).
    • New action: take names from a list or a file.

1.x versions:

  • 1.4.0 (08/09/2001)
    • "Preview" function that allows you to see what the names will look like without modifying anything on the disk.
    • "Undo" function that restores names before the renaming process (for files that are still in the list).
    • Contextual menu in the file list allowing to move items (if you want to change the order of the files before they are renamed).
    • Improved some small things, most of them are not visible but make the source code cleaner.
  • 1.3.1 (23/03/2001)
    • Corrected some small problems with the "Change extension" feature.
    • Corrected a bug when drag & drop a folder on the program's window.
    • Now the program saves in its configuration file all the renaming options that where used last time.
  • 1.3.0 (14/02/2001)
    • Use of the track number for the mp3s (ID3v1.1).
    • Case change (uppercase, lowercase, first letter of each word in uppercase, ...).
    • Some small details.
  • 1.2.1 (20/10/2000)
    • Fixed a bug in the Options window.
    • Can replace invalid characters in filenames such as : < > * | ¦ / \ ? when they are in a mp3 tag.
  • 1.2.0 (07/10/2000)
    • Random names creation.
    • You can add files to the list by a drag & drop from Windows' Explorer.
  • 1.1.1 (20/09/2000)
    • New extension replacement option : enumeration.
  • 1.1.0 (15/09/2000)
    • Easy translation by addition of two files (lng and txt).
  • 1.0.0 (13/09/2000)
    • First release.


Ant Renamer Help

About the author, credits & links

This program has been made by Antoine Potten with Borland Delphi 7 under Windows XP.

It has been designed to run on Windows NT4 SP4, 2000 and XP. It should work fine on Windows 98 and ME too (except unicode support).

You may need to update your system if you are running Windows 98 or NT4. See the download page of my site for links to download updates from Microsoft's website.

At first, I made this program because the only file renamers that I found were shareware.

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR APARTICULAR PURPOSE. See the GNU General Public License for more details.

Contact

  • E-mail : antrenamer-contact@antp.be
  • Web page of Ant Renamer : www.antp.be/software/renamer

Links

Icons used in icon themes:

  • Scrows' glyphs collections

Components used:

  • InnoSetup, used for installation procedure
  • Some components from the JVCL
  • CorelButton
  • Toolbar2000 & TBX
  • VirtualTreeview
  • Tnt Unicode Controls
  • dEXIF
  • TRegExpr library

Thanks to

  • Sebastien Buysse, Gregory Zicot and Michel Potten
  • ... And to all the people that sent me suggestion and comments, and of course those that use the program.

Translations

  • Belarussian: dzmitry[li]
  • Chinese (Simplified): 林繁 (Lin Fan)
  • Chinese (Traditional): Jim Liu
  • Czech: CVG
  • French: Antoine Potten
  • German: Volker Schmidt
  • Greek: Wasilis Mandratzis
  • Hungarian: Zoltán Danhauser
  • Italian: Salvatore Meschini
  • Korean: Seunghoe Yang
  • Polish: Arek Czak
  • Russian: Denny
  • Spanish: Vico//Koby, Roberto Paiva & elega


InteroperabilityIndex
InteroperabilityVersion
ACDComment
NewSubfileType
SubfileType
ImageWidth
ImageLength
BitsPerSample
Compression
PhotometricInterpretation
FillOrder
DocumentName
ImageDescription
Make
Model
StripOffsets
Orientation
SamplesPerPixel
RowsPerStrip
StripByteCounts
MinSampleValue
MaxSampleValue
XResolution
YResolution
PlanarConfiguration
PageName
XPosition
YPosition
FreeOffsets
FreeByteCounts
GrayReponseUnit
GrayReponseCurve
T4Options
T6Options
ResolutionUnit
PageNumber
TransferFunction
Software
DateTime
Artist
HostComputer
Predictor
WhitePoint
PrimaryChromaticities
ColorMap
HalfToneHints
TileWidth
TileLength
TileOffsets
TileByteCounts
SubIFDs
InkSet
InkNames
NumberOfInks
DotRange
TargetPrinter
ExtraSample
SampleFormat
SMinSampleValue
SMaxSampleValue
TransferRange
ClipPath
XClipPathUnits
YClipPathUnits
Indexed
JPEGTables
OPIProxy
JPEGProc
JPEGInterchangeFormat
JPEGInterchangeFormatLength
JPEGRestartInterval
JPEGLosslessPredictors
JPEGPointTransforms
JPEGQTables
JPEGDCTables
JPEGACTables
YCbCrCoefficients
YCbCrSubSampling
YCbCrPositioning
ReferenceBlackWhite
ExtensibleMetadataPlatform
Gamma
ICCProfileDescriptor
SRGBRenderingIntent
ImageTitle
RelatedImageFileFormat
RelatedImageWidth
RelatedImageHeight
ResolutionXUnit
ResolutionYUnit
ResolutionXLengthUnit
ResolutionYLengthUnit
PrintFlags
PrintFlagsVersion
PrintFlagsCrop
PrintFlagsBleedWidth
PrintFlagsBleedWidthScale
HalftoneLPI
HalftoneLPIUnit
HalftoneDegree
HalftoneShape
HalftoneMisc
HalftoneScreen
JPEGQuality
GridSize
ThumbnailFormat
ThumbnailWidth
ThumbnailHeight
ThumbnailColorDepth
ThumbnailPlanes
ThumbnailRawBytes
ThumbnailSize
ThumbnailCompressedSize
ColorTransferFunction
ThumbnailData
ThumbnailImageWidth
ThumbnailImageHeight
ThumbnailBitsPerSample
ThumbnailCompression
ThumbnailPhotometricInterp
ThumbnailImageDescription
ThumbnailEquipMake
ThumbnailEquipModel
ThumbnailStripOffsets
ThumbnailOrientation
ThumbnailSamplesPerPixel
ThumbnailRowsPerStrip
ThumbnailStripBytesCount
ThumbnailResolutionX
ThumbnailResolutionY
ThumbnailPlanarConfig
ThumbnailResolutionUnit
ThumbnailTransferFunction
ThumbnailSoftwareUsed
ThumbnailDateTime
ThumbnailArtist
ThumbnailWhitePoint
ThumbnailPrimaryChromaticities
ThumbnailYCbCrCoefficients
ThumbnailYCbCrSubsampling
ThumbnailYCbCrPositioning
ThumbnailRefBlackWhite
ThumbnailCopyRight
LuminanceTable
ChrominanceTable
FrameDelay
LoopCount
PixelUnit
PixelPerUnitX
PixelPerUnitY
PaletteHistogram
ImageID
Matteing
DataType
ImageDepth
TileDepth
CFARepeatPatternDim
CFAPattern
BatteryLevel
Copyright
ExposureTime
FNumber
IPTC/NAA
IT8RasterPadding
IT8ColorTable
ImageResourceInformation
ExifOffset
InterColorProfile
ExposureProgram
SpectralSensitivity
GPSInfo
ISOSpeedRatings
OECF
Interlace
TimeZoneOffset
SelfTimerMode
ExifVersion
DateTimeOriginal
DateTimeDigitized
ComponentsConfiguration
CompressedBitsPerPixel
ShutterSpeedValue
ApertureValue
BrightnessValue
ExposureBiasValue
MaxApertureValue
SubjectDistance
MeteringMode
LightSource
Flash
FocalLength
FlashEnergy
SpatialFrequencyResponse
Noise
FocalPlaneXResolution
FocalPlaneYResolution
FocalPlaneResolutionUnit
ImageNumber
SecurityClassification
ImageHistory
SubjectLocation
ExposureIndex
TIFF/EPStandardID
SensingMethod
StoNits
MakerNote
UserComment
SubSecTime
SubSecTimeOriginal
SubSecTimeDigitized
ImageSourceData
Title
Comments
Author
Keywords
Subject
FlashPixVersion
ColorSpace
ExifImageWidth
ExifImageLength
RelatedSoundFile
InteroperabilityOffset
FlashEnergy
SpatialFrequencyResponse
FocalPlaneXResolution
FocalPlaneYResolution
FocalPlaneResolutionUnit
ImageNumber
SecurityClassification
ImageHistory
SubjectLocation
ExposureIndex
TIFF/EPStandardID
SensingMethod
FileSource
SceneType
CFAPattern
CustomRendered
ExposureMode
WhiteBalance
DigitalZoomRatio
FocalLengthin35mmFilm
SceneCaptureType
GainControl
Contrast
Saturation
Sharpness
DeviceSettingDescription
SubjectDistanceRange
ImageUniqueID